//+------------------------------------------------------------------+
//|                                                Awesome_ZOTIK.mq4 |
//|                                                    zot@pisem.net |
//+------------------------------------------------------------------+
#property  copyright "Copyright  2005, MetaQuotes Software Corp."
#property  link      "http://www.metaquotes.net/"
//---- indicator settings
#property  indicator_separate_window
#property  indicator_buffers 5
#property  indicator_color1  CLR_NONE
#property  indicator_color2  Green
#property  indicator_color3  Red
#property  indicator_color4  Aqua
#property  indicator_color5  Yellow
//---- indicator parameters
extern int FastSMA=5;
extern int SlowSMA=34;
extern int FastEMA=21;
extern int SlowEMA=55;
extern int VLine=34;
//---- indicator buffers
double     ExtBuffer0[2];
double     ExtBuffer1[2];
double     ExtBuffer2[2];
double     EMA[2];
double     V[2];

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
   //---- drawing settings
   SetIndexStyle(0,DRAW_LINE);
   SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexStyle(2,DRAW_HISTOGRAM);
   SetIndexStyle(3,DRAW_LINE);
   SetIndexStyle(4,DRAW_LINE);
   IndicatorDigits(Digits+1);
   SetIndexDrawBegin(0,34);
   SetIndexDrawBegin(1,34);
   SetIndexDrawBegin(2,34);
//---- 3 indicator buffers mapping
   SetIndexBuffer(0,ExtBuffer0);
   SetIndexBuffer(1,ExtBuffer1);
   SetIndexBuffer(2,ExtBuffer2);
   SetIndexBuffer(3,EMA);
   SetIndexBuffer(4,V);
//---- name for DataWindow and indicator subwindow label
   IndicatorShortName("AO_Zotik("+FastSMA+","+SlowSMA+"|"+FastEMA+","+SlowEMA+"|"+VLine+")");
   SetIndexLabel(1,NULL);
   SetIndexLabel(2,NULL);
   SetIndexLabel(3,NULL);
   SetIndexLabel(4,NULL);
//---- initialization done
   return(0);
  }
//+------------------------------------------------------------------+
//| Awesome Oscillator                                               |
//+------------------------------------------------------------------+
int start()
  {
   int    limit;
   int    counted_bars=IndicatorCounted();
   double prev,current;
//---- last counted bar will be recounted
   if(counted_bars>0) counted_bars--;
   limit=Bars-counted_bars;
//---- ao
   for(int i=0; i<limit; i++)
      ExtBuffer0[i]=iMA(NULL,0,FastSMA,0,MODE_SMA,PRICE_MEDIAN,i)-iMA(NULL,0,SlowSMA,0,MODE_SMA,PRICE_MEDIAN,i);
//---- EMA
   for(i=0; i<limit; i++)
      EMA[i]=iMA(NULL,0,FastEMA,0,MODE_EMA,PRICE_CLOSE,i)-iMA(NULL,0,SlowEMA,0,MODE_EMA,PRICE_CLOSE,i);
//---- V
   for(i=0; i<limit; i++)
      V[i]=iMA(NULL,0,VLine,0,MODE_EMA,PRICE_CLOSE,i)-iMA(NULL,0,VLine,0,MODE_SMA,PRICE_MEDIAN,i);    
//---- dispatch values between 2 buffers
   bool up=true;
   for(i=limit-1; i>=0; i--)
     {
      current=ExtBuffer0[i];
      prev=ExtBuffer0[i+1];
      if(current>prev) up=true;
      if(current<prev) up=false;
      if(!up)
        {
         ExtBuffer2[i]=current;
         ExtBuffer1[i]=0.0;
        }
      else
        {
         ExtBuffer1[i]=current;
         ExtBuffer2[i]=0.0;
        }
     }
//---- done
   return(0);
  }
//+------------------------------------------------------------------+

